# echarts-composables

Composables of EChart.

> This project still under quick developing, please be careful of using it in your production environment.
 
## Quick Start

```bash
npm install echarts-composables
```

```typescript
import { useEChartOption, DimensionType, MetricType } from 'echarts-composables';

const dataset = [
  ['Date', 'Data1', 'Data2'],
  ['2020', 450, 1233],
  ['2021', 23, 567],
  ['2022', 57, 77],
];

const dimensions = [{ 
  key: 'Date',
  visual: DimensionType.CategoryAxis,
}];

const metrics = [{
  key: 'Data1',
  visual: DimensionType.Bar,
}, {
  key: 'Data2',
  visual: DimensionType.Bar,
}];

const option = useEChartOption(dataset, dimensions, metrics);
```
