import { type BasicDataset, type BasicDimension, type BasicMetric, type EChartOptionAddon, type NormalizedEChartOption } from '../echarts/types';
export declare function useEChartOption(dataset: BasicDataset, dimensions: BasicDimension | BasicDimension[], metrics: BasicMetric | BasicMetric[], addons?: EChartOptionAddon[]): NormalizedEChartOption;
export declare class EChartOptionBuilder {
    private built;
    private readonly handlers;
    constructor(addons?: EChartOptionAddon[]);
    build(): (dataset: BasicDataset, dimensions: BasicDimension | BasicDimension[], metrics: BasicMetric | BasicMetric[], addons?: EChartOptionAddon[]) => NormalizedEChartOption;
}
