var H = Object.defineProperty;
var G = (r, t, a) => t in r ? H(r, t, { enumerable: !0, configurable: !0, writable: !0, value: a }) : r[t] = a;
var $ = (r, t, a) => (G(r, typeof t != "symbol" ? t + "" : t, a), a);
var v = /* @__PURE__ */ ((r) => (r.CategoryAxis = "categoryAxis", r.Series = "series", r.RadarIndicator = "radarIndicator", r))(v || {}), m = /* @__PURE__ */ ((r) => (r.Bar = "bar", r.Line = "line", r.Radar = "radar", r.Pie = "pie", r.Funnel = "funnel", r))(m || {});
function b(r) {
  return r === 0 || !!r;
}
function O(r) {
  const t = [], a = r[0];
  for (let c = 1; c < r.length; c++) {
    const i = {};
    for (let o = 0; o < a.length; o++)
      i[`${a[o]}`] = r[c][o];
    t.push(i);
  }
  return t;
}
function Y(r, t, a, c = []) {
  var z, L, B, M;
  if (t = Array.isArray(t) ? t : [t], a = Array.isArray(a) ? a : [a], r.length === 0)
    return { series: [] };
  r = Array.isArray(r[0]) ? O(r) : r;
  const i = { series: [] };
  i.grid = {
    top: 40,
    right: 20,
    bottom: 50
  };
  const o = t.find((e) => e.visual === v.CategoryAxis), n = t.find((e) => e.visual === v.Series), u = t.find((e) => e.visual === v.RadarIndicator), d = a.filter((e) => e.visual === m.Bar);
  for (const e of d) {
    if (!o)
      continue;
    const y = r.filter((s) => b(s[e.key]));
    let l = [];
    n ? l = Array.from(new Set(y.map((s) => s[n.key]))) : l = [e.key], i.series.push(
      ...l.map((s) => {
        const p = (n ? y.filter((f) => f[n.key] === s) : y).map((f) => [f[o == null ? void 0 : o.key], f[e.key]]);
        return {
          type: "bar",
          name: s,
          data: p,
          itemStyle: {
            borderRadius: [4, 4, 0, 0]
          },
          barWidth: 16,
          barGap: "50%"
        };
      })
    );
  }
  const w = a.filter((e) => e.visual === m.Line);
  for (const e of w) {
    if (!o)
      continue;
    const y = r.filter((s) => b(s[e.key]));
    let l = [];
    n ? l = Array.from(new Set(y.map((s) => s[n.key]))) : l = [e.key], i.series.push(
      ...l.map((s) => {
        const p = (n ? y.filter((f) => f[n.key] === s) : y).map((f) => [f[o == null ? void 0 : o.key], f[e.key]]);
        return {
          type: "line",
          name: s,
          data: p,
          itemStyle: {
            borderWidth: 2
          },
          lineStyle: {
            width: 3
          },
          showSymbol: !1,
          symbolSize: 0,
          symbol: "circle",
          smooth: !0
        };
      })
    );
  }
  const k = a.find((e) => e.visual === m.Pie);
  if (k) {
    const y = r.filter((l) => b(l[k.key])).map((l) => ({
      name: n ? l[n.key] : k.key,
      value: +l[k.key]
    }));
    i.series.push({
      type: "pie",
      name: (z = n == null ? void 0 : n.key) != null ? z : k.key,
      data: y,
      itemStyle: {
        borderWidth: 3,
        borderColor: "#fff"
      },
      label: {
        formatter: (l) => {
          var s;
          return ((s = l.percent) == null ? void 0 : s.toFixed(2)) + "%";
        }
      }
    });
  }
  const x = a.find((e) => e.visual === m.Funnel);
  if (x) {
    const y = r.filter((l) => b(l[x.key])).map((l) => ({
      name: n ? l[n.key] : x.key,
      value: +l[x.key]
    }));
    i.series.push({
      type: "funnel",
      name: (L = n == null ? void 0 : n.key) != null ? L : x.key,
      data: y,
      gap: 0,
      label: {
        formatter: (l) => {
          var s;
          return ((s = l.percent) == null ? void 0 : s.toFixed(2)) + "%";
        }
      }
    });
  }
  const h = a.filter((e) => e.visual === m.Radar), A = [], S = [], F = r.filter((e) => h.some(
    (y) => b(e[y.key])
  ));
  u && S.push(
    ...Array.from(
      new Set(F.map((e) => `${e[u.key]}`))
    ).map((e) => ({ name: e }))
  );
  let g = [];
  if (n && u && h.length === 1) {
    const e = h[0], y = r.filter((l) => b(l[e.key]));
    g = Array.from(new Set(y.map((l) => `${l[n.key]}`))), A.push(...g.map((l) => {
      const s = S.map(
        (p) => {
          var f, W;
          return +((W = (f = y.find(
            (D) => `${D[u.key]}` === p.name && `${D[n.key]}` === l
          )) == null ? void 0 : f[e.key]) != null ? W : 0);
        }
      );
      return {
        name: l,
        value: s
      };
    }));
  } else
    !n && u && (g = h.map((e) => e.key), A.push(...g.map((e) => {
      const y = S.map(
        (l) => {
          var s, p;
          return +((p = (s = F.find(
            (f) => `${f[u.key]}` === l.name
          )) == null ? void 0 : s[e]) != null ? p : 0);
        }
      );
      return {
        name: e,
        value: y
      };
    })));
  u && A.length > 0 && (i.radar = {
    indicator: S
  }, i.series.push({
    type: "radar",
    name: h.length === 1 ? h[0].key : "radar",
    data: A
  })), o && (i.xAxis = [{ type: "category" }], i.yAxis = [{ type: "value" }]);
  const I = i.series.every((e) => e.type === "line"), P = i.series.every((e) => e.type === "bar"), R = i.series.every((e) => e.type === "pie"), C = i.series.every((e) => e.type === "funnel"), E = i.series.every((e) => e.type === "radar");
  return I && ((B = i.xAxis) == null || B.forEach((e) => {
    e.type === "category" && (e.boundaryGap = !1);
  })), i.tooltip = {
    show: !0,
    backgroundColor: "rgba(60, 63, 70, 0.7)",
    borderWidth: 0,
    textStyle: {
      color: "#fff",
      fontFamily: "Microsoft YaHei",
      lineHeight: 20,
      fontSize: 12
    },
    trigger: R || C || E ? "item" : "axis",
    axisPointer: {
      shadowStyle: { color: "rgba(153, 153, 153, 0.2)" },
      type: P ? "shadow" : "line"
    },
    confine: !0,
    extraCssText: "box-shadow: 0px 1px 9px 0px rgba(0,0,0,0.1); border-radius: 8px; border: 0.5px solid #FFFFFF 0.16;"
  }, i.legend = {
    show: !0,
    type: "scroll",
    itemWidth: 8,
    itemHeight: 8,
    orient: "horizontal",
    left: "center",
    bottom: 5,
    textStyle: {
      fontSize: 12
    },
    data: R || C || E ? (M = i.series[0].data) == null ? void 0 : M.map(({ name: e }) => ({ icon: "circle", name: `${e}` })) : i.series.map((e) => e.type === "line" ? { icon: "path:// M0 0 L 200 0 L 200 40 L 0 40", name: `${e.name}` } : { icon: "circle", name: `${e.name}` })
  }, c == null || c.forEach((e) => {
    e(i);
  }), i;
}
class j {
  constructor(t = []) {
    $(this, "built");
    $(this, "handlers");
    this.built = !1, this.handlers = t;
  }
  build() {
    return this.built = !0, (t, a, c, i = []) => Y(t, a, c, [...this.handlers, ...i]);
  }
}
function q() {
  return (r) => {
    !r.xAxis || !r.yAxis || r.xAxis.every((t) => t.type === "category") && r.yAxis.every((t) => t.type === "value") && (r.xAxis.forEach((t) => {
      t.type = "value";
    }), r.yAxis.forEach((t) => {
      t.type = "category";
    }), r.series.forEach((t) => {
      if ((t.type === "line" || t.type === "bar") && Array.isArray(t.data) && (t.data = t.data.map(
        (a) => Array.isArray(a) ? [a[1], a[0]] : a
      )), t.type === "bar" && t.itemStyle && Array.isArray(t.itemStyle.borderRadius)) {
        const [a, c, i, o] = t.itemStyle.borderRadius;
        t.itemStyle.borderRadius = [o, a, c, i];
      }
    }));
  };
}
function J() {
  return (r) => {
    const t = r.series.filter((a) => a.type === "line");
    for (const a of t)
      a.areaStyle = {
        opacity: 0.3
      };
  };
}
function K(r) {
  const {
    inner: t = 36,
    outer: a = 56,
    showTotal: c = !1
  } = r != null ? r : {};
  return (i) => {
    const o = i.series.filter((n) => n.type === "pie");
    for (const n of o)
      n.radius = [`${t}%`, `${a}%`];
    if (c && o.length === 1 && Array.isArray(o[0].data) && o[0].data.length > 0) {
      const n = [];
      typeof o[0].data[0] == "number" ? n.push(...o[0].data) : Array.isArray(o[0].data[0]) ? n.push(...o[0].data.map((d) => d[0])) : n.push(...o[0].data.map((d) => d.value));
      const u = n.reduce((d, w) => d + w, 0);
      i.graphic = {
        elements: [{
          type: "text",
          left: "center",
          top: "42%",
          style: {
            text: `${u}`,
            fontSize: 28
          },
          cursor: "default"
        }, {
          type: "text",
          left: "center",
          top: "54%",
          style: {
            text: `${o[0].name}`,
            fontSize: 12
          },
          cursor: "default"
        }]
      };
    }
  };
}
function N() {
  return (r) => {
    r.series.filter((a) => a.type === "radar").forEach((a) => {
      a.areaStyle || (a.areaStyle = {}), a.areaStyle.opacity = 0.3;
    });
  };
}
export {
  v as DimensionType,
  j as EChartOptionBuilder,
  m as MetricType,
  K as useDonut,
  Y as useEChartOption,
  J as useLineArea,
  N as useRadarArea,
  q as useYAxisAsCategory
};
